package com.rf.psychological.scale.resultBusiness.scaleResult;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.rf.psychological.utils.Constant;

import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

/**
 * @description 社会适应能力诊断量表
 */
public class SADSScale extends BaseScale {
    public SADSScale(JSONArray jsonArray, JSONObject resultJson) {
        super(jsonArray, resultJson);
    }

    public JSONObject scaleCalculate() throws Exception {
        //总分
        int score = 0;

        for (int i = 0; i < jsonArray.size(); i++) {
            JSONObject jsonObject1 = jsonArray.getJSONObject(i);

            if (jsonObject1.getString("scoreDirection").equals("1")) {
                if (jsonObject1.getString("checkItems").equals("是")) {
                    score += -2;
                } else if (jsonObject1.getString("checkItems").equals("无法肯定")) {
                    score += 0;
                } else if (jsonObject1.getString("checkItems").equals("不是")) {
                    score += 2;
                }
            } else if (jsonObject1.getString("scoreDirection").equals("0")) {
                if (jsonObject1.getString("checkItems").equals("是")) {
                    score += 2;
                } else if (jsonObject1.getString("checkItems").equals("无法肯定")) {
                    score += 0;
                } else if (jsonObject1.getString("checkItems").equals("不是")) {
                    score += -2;
                }
            }

        }


        //得分列表
        Map<String, String> resultMap = new LinkedHashMap<>();
        resultMap.put("总分", String.valueOf(score));
        resultJson.put("总分", String.valueOf(score));


        if (score >= 35 && score <= 40) {
            resultMap.put("总分结论", "社会适应能力很强，能很快地适应新的学习、生活环境，与人交往轻松、大方，给人的印象极好，无论进入什么样的环境，都能应付自如。 ");
            resultJson.put("总分结论", "社会适应能力很强，能很快地适应新的学习、生活环境，与人交往轻松、大方，给人的印象极好，无论进入什么样的环境，都能应付自如。 ");
        } else if (score >= 29 && score <= 34) {
            resultMap.put("总分结论", "你能够较好的适应环境的变化，态度积极，乐于与外界交往，有较强的调适能力。");
            resultJson.put("总分结论", "你能够较好的适应环境的变化，态度积极，乐于与外界交往，有较强的调适能力。");
        } else if (score >= 17 && score <= 28) {
            resultMap.put("总分结论", "社会适应能力一般，当进入一个新环境，经过一段时间的努力， 基本上能适应。 ");
            resultJson.put("总分结论", "社会适应能力一般，当进入一个新环境，经过一段时间的努力， 基本上能适应。 ");
        } else if (score >= 6 && score <= 16) {
            resultMap.put("总分结论", "社会适应能力较差，依赖于较好的学习、生活环境，一旦遇到困难则易怨天尤人，甚至消沉。你需要在今后的学习、生活、工作中，有意识的培养自己在这方面的能力，以提高心理承受力和适应能力。");
            resultJson.put("总分结论", "社会适应能力较差，依赖于较好的学习、生活环境，一旦遇到困难则易怨天尤人，甚至消沉。你需要在今后的学习、生活、工作中，有意识的培养自己在这方面的能力，以提高心理承受力和适应能力。");
        } else if (score <= 5) {
            resultMap.put("总分结论", "社会适应能力很差，在各种新环境中，即使经过一段相当长时间的努力，也不一定能够适应，常常困惑到与周围事物格格不入而十分苦恼。在与他人的交往中，总是显得拘谨，羞怯，手足无措。");
            resultJson.put("总分结论", "社会适应能力很差，在各种新环境中，即使经过一段相当长时间的努力，也不一定能够适应，常常困惑到与周围事物格格不入而十分苦恼。在与他人的交往中，总是显得拘谨，羞怯，手足无措。");
        }


        List<Map<String, String>> resultMapList = new ArrayList<>();
        resultMapList.add(resultMap);

        JSONObject returnJson = new JSONObject(true);
        returnJson.put("resultMapList", resultMapList);
        returnJson.put("scaleName", Constant.SHEET_NAME_SADS);
        returnJson.put("resultJson", resultJson);

        return returnJson;
    }
}
